<?php

// Die if we are called via web, we only want to be run from command line
// if (php_sapi_name() !='cli') exit;

require_once("config.php");
require_once("system.php");
require_once("xml2array.php");
require_once("dblib.php");
require_once("asmanager.php");
require_once("functions.inc.php");
require_once("dbconn.php");

// This script will update all the fop2 tables with information about the system
// This is needed to be run whenever there is a change in the PBX configuration
// or when asterisk is reloaded. So, the same fop2 could run this script on
// RELOAD!!

$qry = "REPLACE INTO fop2groups values('-1','All Buttons')";
$results = $db->consulta($qry);
$qry = "REPLACE INTO fop2groups values('-2','All Extensions')";
$results = $db->consulta($qry);
$qry = "REPLACE INTO fop2groups values('-3','All Queues')";
$results = $db->consulta($qry);
$qry = "REPLACE INTO fop2groups values('-4','All Conferences')";
$results = $db->consulta($qry);
$qry = "REPLACE INTO fop2groups values('-5','All Trunks')";
$results = $db->consulta($qry);

$channels = system_all_values('channel');
$types    = system_all_values('type');
$fop2_buttons   = fop2_all_buttons();

$sql = "DELETE FROM fop2GroupButton WHERE group_name='All Buttons'";
$results = $db->consulta($sql);

// All Extension = -2
$sql = "DELETE FROM fop2GroupButton WHERE group_name='All Extensions'";
$results = $db->consulta($sql);
foreach($channels as $chan=>$val) {
    if($types[$chan]=='extension') {
        $btid = $fop2_buttons[$val]['devid'];
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Extensions','$btid')";
        $results = $db->consulta($sql);
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Buttons','$btid')";
        $results = $db->consulta($sql);
    }
}

// All Queues
$sql = "DELETE FROM fop2GroupButton WHERE group_name='All Queues'";
$results = $db->consulta($sql);
foreach($channels as $chan=>$val) {
    if($types[$chan]=='queue') {
        $btid = $fop2_buttons[$val]['devid'];
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Queues','$btid')";
        $results = $db->consulta($sql);
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Buttons','$btid')";
        $results = $db->consulta($sql);
    }
}

// All Conferences 
$sql = "DELETE FROM fop2GroupButton WHERE group_name='All Conferences'";
$results = $db->consulta($sql);
foreach($channels as $chan=>$val) {
    if($types[$chan]=='conference') {
        $btid = $fop2_buttons[$val]['devid'];
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Conferences','$btid')";
        $results = $db->consulta($sql);
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Buttons','$btid')";
        $results = $db->consulta($sql);
    }
}

// All Trunks 
$sql = "DELETE FROM fop2GroupButton WHERE group_name='All Trunks'";
$results = $db->consulta($sql);
foreach($channels as $chan=>$val) {
    if($types[$chan]=='trunk') {
        $btid = $fop2_buttons[$val]['devid'];
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Trunks','$btid')";
        $results = $db->consulta($sql);
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Buttons','$btid')";
        $results = $db->consulta($sql);
    }
}

foreach($channels as $chan=>$val) {
    if($types[$chan]=='park' || $types[$chan]=='ringgroup') {
        $btid = $fop2_buttons[$val]['devid'];
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Buttons','$btid')";
        $results = $db->consulta($sql);
    }
}

$system_buttons = system_all_buttons();

if(!isset($fop2_buttons))   { $fop2_buttons = array(); }
if(!isset($system_buttons)) { $system_buttons = array(); }

$del_buttons = array_diff(array_keys($fop2_buttons),array_keys($system_buttons));
$add_buttons = array_diff(array_keys($system_buttons),array_keys($fop2_buttons));

if(!isset($del_buttons)) { $del_buttons = array(); }
if(!isset($add_buttons)) { $add_buttons = array(); }

// Remove buttons that are not in the system anymore
foreach($del_buttons as $chan) {
    $result = $db->select('id,exten','fop2buttons','',"device='$chan'");
    $id     = $result[0]['id'];
    $exten  = $result[0]['exten'];
    fop2_del_button($id,$exten);
}

foreach($add_buttons as $chan=>$dat) {

    $det = $system_buttons[$dat];
    $queuechannel = (isset($det['queuechannel']))?$det['queuechannel']:'';
    $customastdb  = (isset($det['customastdb']))?$det['customastdb']:'';
    $mailbox      = (isset($det['mailbox']))?$det['mailbox']:'';
    $email        = (isset($det['email']))?$det['email']:'';
    $group        = (isset($det['group']))?$det['group']:'';
    $external     = (isset($det['external']))?$det['external']:'';

    $results = $db->consulta( 
        "REPLACE INTO fop2buttons (type, device, label, exten, context, mailbox, queuechannel, customastdb, email, `group`, external) ".
        "VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s')", 
        array($det['type'],$det['channel'],$det['name'],$det['exten'],$det['context'],$mailbox,$queuechannel,$customastdb,$email,$group,$external) 
    );
}

if($config_engine=='freepbx') {
    // If we are on FreePBX, then update queuechannel and mailbox automagically
    foreach($system_buttons as $chan=>$dat) {
        if($dat['type']=='extension') {
            $fop2qchan = $fop2_buttons[$chan]['queuechannel'];
            $fop2mbox  = $fop2_buttons[$chan]['mailbox'];
            if($fop2qchan <> $dat['queuechannel']) {
                $query = "UPDATE fop2buttons SET queuechannel='%s' WHERE device='%s'";
                $db->consulta($query,array($dat['queuechannel'],$chan));
                $need_update=1;
            }
            if($fop2mbox <> $dat['mailbox']) {
                $query = "UPDATE fop2buttons SET mailbox='%s' WHERE device='%s'";
                $db->consulta($query,array($dat['mailbox'],$chan));
                $need_update=1;
            }
        }
    }
}

plugin_insert_missing_db();


